function updateScreenOffset()
{
	cancel( $updateScreenOffset );
 
	if ( !isObject( %sc = nameToID( "serverConnection" ) ) )
	{
		$dofX = 0;
		$dofY = 0;
		playGUI.cameraZRot = 0;
 
		return;
	}
 
	%co = %sc.getControlObject();
 
	if ( !( %co.getType() & $TypeMasks::PlayerObjectType ) || !$firstPerson )
	{
		$dofX = 0;
		$dofY = 0;
		playGUI.cameraZRot = 0;
 
		$updateScreenOffset = schedule( 16, 0, "updateScreenOffset" );
		return;
	}
 
	%vl = %co.getVelocity();
	%fv = %co.getForwardVector();
 
	%vx = getWord( %vl, 0 );
	%vy = getWord( %vl, 1 );
 
	%fx = getWord( %fv, 0 );
	%fy = getWord( %fv, 1 );
 
	%nx = mClampF( %vx * %fy + %vy * %fx, -1, 1 );
	%ny = mClampF( %vy * %fy + %vx * -%fx, -1, 1 );
 
	%ny = 0;
	%nz = %nx * 4;

	%rot = getWord( axisToEuler( getWords( %co.getTransform(), 3, 6 ) ), 2 );

	if((%rot > 45 && %rot < 135) || (%rot < -45 && %rot > -135))
	{
		%nx = -%nx;
		%ny = -%ny;
	}
	else
	{
		%nz = -%nz;
	}
 
	%dx = mClampF( mAbs( %nx - $dofX ), 0, 2 );
	%dy = mClampF( mAbs( %ny - $dofY ), 0, 2 );
	%dz = mClampF( mAbs( %nz - playGUI.cameraZRot ), 0, 2 );
 
	%sx = mClampF( %dx / 2, 0.01, 5 );
	%sy = mClampF( %dy / 2, 0.01, 5 );
	%sz = mClampF( %dz / 2, 0.01, 5 );
 
	%rx = 0.2 * %sx;
	%ry = 0.2 * %sy;
	%rz = 0.2 * %sz;

	if ( %sp > 2 )
	{
		%ts = mFloor( ( 400 - %sp ) / 32 );

		if ( ( $bobWalkTime++ ) >= %ts )
		{
			$bobWalkTime = 0;

			$bobWalkFactor = !$bobWalkFactor;
		}

		if ( false )
		{
			%rx = -%rx + %s;
			%ry = -%ry + %s;
			%rz = -%rz + %s;
		}
	}
 
	if ( $dofX < %nx )
	{
		$dofX += %rx;
 
		if ( $dofX > %nx )
		{
			$dofX = %nx;
		}
	}
	else if ( $dofX > %nx )
	{
		$dofX -= %rx;
 
		if ( $dofX < %nx )
		{
			$dofX = %nx;
		}
	}
 
	if ( $dofY < %ny )
	{
		$dofY += %ry;
 
		if ( $dofY > %ny )
		{
			$dofY = %ny;
		}
	}
	else if ( $dofY > %ny )
	{
		$dofY -= %ry;
 
		if ( $dofY < %ny )
		{
			$dofY = %ny;
		}
	}
 
	if ( playGUI.cameraZRot < %nz )
	{
		playGUI.cameraZRot += %rz;
 
		if ( $dofX > %nz )
		{
			playGUI.cameraZRot = %nz;
		}
	}
	else if ( playGUI.cameraZRot > %nz )
	{
		playGUI.cameraZRot -= %rz;
 
		if ( playGUI.cameraZRot < %nz )
		{
			playGUI.cameraZRot = %nz;
		}
	}

	%b = playGUI.cameraZRot / 5;
	$bobCross = %b - %b - %b;

	if( $bobCross > 30 )
		$bobCross = 30;

	if( $bobCross < -30 )
		$bobCross = -30;

	%res = getRes();

	Crosshair.position = ( ( getWord( %res, 0 ) / 2 ) - 8 ) + ( $bobCross - $bobCross - $bobCross ) * 18 SPC ( getWord( %res, 1 ) / 2 ) - 8;

	$updateScreenOffset = schedule( 16, 0, "updateScreenOffset" );
}

function doWonkyShader()
{
	cancel($doWonkyShader);

	if(!isObject( %sc = serverConnection ))
	{
		$dofX = 0;
		$dofY = 0;

		return;
	}

	if(!isObject( %pl = serverConnection.getControlObject() ))
	{
		return;
	}

	%vl = %pl.getVelocity();
	%fv = %pl.getForwardVector();
 
	%vx = getWord( %vl, 0 );
	%vy = getWord( %vl, 1 );
 
	%fx = getWord( %fv, 0 );
	%fy = getWord( %fv, 1 );
 
	%nx = %vx * %fy + %vy * %fx;
	%ny = %vy * %fy + %vx * -%fx;

	$dofX = -%nx;
	$dofY = -%ny;

	$doWonkyShader = schedule( 16, 0, "doWonkyShader" );
}

//Trader
function eulerToAxis(%euler)
{
	%euler = VectorScale(%euler,$pi / 180);
	%matrix = MatrixCreateFromEuler(%euler);
	return getWords(%matrix,3,6);
}

function axisToEuler(%axis)
{
	%angleOver2 = getWord(%axis,3) * 0.5;
	%angleOver2 = -%angleOver2;
	%sinThetaOver2 = mSin(%angleOver2);
	%cosThetaOver2 = mCos(%angleOver2);
	%q0 = %cosThetaOver2;
	%q1 = getWord(%axis,0) * %sinThetaOver2;
	%q2 = getWord(%axis,1) * %sinThetaOver2;
	%q3 = getWord(%axis,2) * %sinThetaOver2;
	%q0q0 = %q0 * %q0;
	%q1q2 = %q1 * %q2;
	%q0q3 = %q0 * %q3;
	%q1q3 = %q1 * %q3;
	%q0q2 = %q0 * %q2;
	%q2q2 = %q2 * %q2;
	%q2q3 = %q2 * %q3;
	%q0q1 = %q0 * %q1;
	%q3q3 = %q3 * %q3;
	%m13 = 2.0 * (%q1q3 - %q0q2);
	%m21 = 2.0 * (%q1q2 - %q0q3);
	%m22 = 2.0 * %q0q0 - 1.0 + 2.0 * %q2q2;
	%m23 = 2.0 * (%q2q3 + %q0q1);
	%m33 = 2.0 * %q0q0 - 1.0 + 2.0 * %q3q3;
	return mRadToDeg(mAsin(%m23)) SPC mRadToDeg(mAtan(-%m13, %m33)) SPC mRadToDeg(mAtan(-%m21, %m22));
}